%define name krb5-fermi-base
%define path /usr/krb5
%define version 2.2
%define release 2

# Following defines are for the %triggerin sections to
# create symbolic links since apparently putting the
# same trigger on multiple %triggerin directives does
# not work (only the first one triggers)
# Basically, a particular trigger (patchname/conditional/version)
# can only appear on a single %triggerin section
# The *unset* macros are for %triggerun scriptlets to
# remove the symbolic links

# Set 1: krb5-workstations < 1.7 | krb5-appl-clients | krb5-appl-servers
%define applset1 ln -sf /usr/kerberos/bin/rcp %{path}/bin/
%define applunset1 rm -f %{path}/bin/rcp

# Set 2: krb5-workstation < 1.7 | krb5-appl-clients
%define applset2 ln -sf /usr/kerberos/bin/ftp %{path}/bin/ \
ln -sf /usr/kerberos/bin/rlogin %{path}/bin/ \
ln -sf /usr/kerberos/bin/rsh %{path}/bin/ \
ln -sf /usr/kerberos/bin/telnet %{path}/bin/ \
ln -sf /usr/kerberos/bin/krlogin %{path}/bin/ \
ln -sf /usr/kerberos/bin/krsh %{path}/bin/
%define applunset2 rm -f %{path}/bin/ftp %{path}/bin/rlogin \
rm -f %{path}/bin/rsh %{path}/bin/telnet %{path}/bin/krlogin \
rm -f %{path}/bin/krsh

# Set 3: krb5-workstation < 1.7 | krb5-appl-servers
%define applset3 ln -sf /usr/kerberos/sbin/ftpd %{path}/sbin/ \
ln -sf /usr/kerberos/sbin/klogind %{path}/sbin/ \
ln -sf /usr/kerberos/sbin/login.krb5 %{path}/sbin/ \
ln -sf /usr/kerberos/sbin/kshd %{path}/sbin/ \
ln -sf /usr/kerberos/sbin/telnetd %{path}/sbin/
%define applunset3 rm -f %{path}/sbin/ftpd %{path}/sbin/klogind \
rm -f %{path}/sbin/login.krb5 %{path}/sbin/kshd %{path}/sbin/telnetd

Summary: Base setup for Fermi Kerberos
Name: %{name}
Version: %{version}
Release: %{release}
Source0: %{name}-%{version}.tar.gz
License: MIT, freely distributable.
URL: http://web.mit.edu/kerberos/www/
Prereq: fileutils
Group: Fermi
BuildArchitectures: noarch
Packager: Frank Nagy  < nagy@fnal.gov > 
BuildRoot: %{_tmppath}/%{name}-%{version}
Requires: krb5-workstation krb5-fermi-config
Obsoletes: krb5-fermi-baseconfig

%description
Kerberos V5 is a trusted-third-party network authentication system,
which can improve your network's security by eliminating the insecure
practice of cleartext passwords.

This package sets up the base configuration for Fermi Kerberos
including the /usr/krb5 directory tree and symbolic links to the
vendor-supplied Kerberos utilities in various locations.

%prep
%setup
rm -rf $RPM_BUILD_ROOT

%install
install -m 0755 -d $RPM_BUILD_ROOT/%{path}/bin
install -m 0755 -d $RPM_BUILD_ROOT/%{path}/config
install -m 0755 -d $RPM_BUILD_ROOT/%{path}/include
install -m 0755 -d $RPM_BUILD_ROOT/%{path}/lib
install -m 0755 -d $RPM_BUILD_ROOT/%{path}/man
install -m 0755 -d $RPM_BUILD_ROOT/%{path}/man/man1
install -m 0755 -d $RPM_BUILD_ROOT/%{path}/man/man5
install -m 0755 -d $RPM_BUILD_ROOT/%{path}/man/man8
install -m 0755 -d $RPM_BUILD_ROOT/%{path}/sbin

install -m 0755 kinit $RPM_BUILD_ROOT/%{path}/bin/
install -m 0755 kinit-debug $RPM_BUILD_ROOT/%{path}/bin/

mkdir -p $RPM_BUILD_ROOT/etc/profile.d

install -m 0755 z_krb5.csh $RPM_BUILD_ROOT/etc/profile.d/z_krb5.csh
install -m 0755 z_krb5.sh $RPM_BUILD_ROOT/etc/profile.d/z_krb5.sh

# Create directories for kcron which is installed by krb5-fermi-addons

install -m 0711 -d $RPM_BUILD_ROOT/var/adm
install -m 2711 -d $RPM_BUILD_ROOT/var/adm/krb5


# Change symbolic links to point to correct locations depending on
# what packages and versions are installed (or uninstalled)

%triggerin -- krb5-workstation < 1.7
echo " >> Adding krb5/bin and krb5/sbin symlinks"
# RHEL/SL/SLF5 versions are MIT 1.6.*
# RHEL5 puts Kerberos stuff in /usr/kerberos
ln -sf /usr/kerberos/bin/kdestroy %{path}/bin/
fpm=`stat -c %a /usr/kerberos/bin/kdestroy`
if [ "$fpm" -eq "4777" -o "$fpm" -eq "0777" ]; then
	echo " >> Correcting kdestroy permissions"
	chmod 4755 /usr/kerberos/bin/kdestroy
fi
ln -sf /usr/kerberos/bin/klist %{path}/bin/
ln -sf /usr/kerberos/bin/kpasswd %{path}/bin/
ln -sf /usr/kerberos/bin/ksu %{path}/bin/
if [ "`stat -c %a /usr/kerberos/bin/ksu`" -eq "4777" ]; then
	echo " >> Correcting ksu permissions"
	chmod 4755 /usr/kerberos/bin/ksu
fi
ln -sf /usr/kerberos/bin/krb524init %{path}/bin/
ln -sf /usr/kerberos/bin/v4rcp %{path}/bin/
fpm=`stat -c %a /usr/kerberos/bin/v4rcp`
if [ "$fpm" -eq "4777" -o "$fpm" -eq "0777" ]; then
	echo " >> Correcting v4rcp permissions"
	chmod 0755 /usr/kerberos/bin/v4rcp
fi
ln -sf /usr/kerberos/bin/kvno %{path}/bin/
ln -sf /usr/kerberos/sbin/k5srvutil %{path}/sbin/
ln -sf /usr/kerberos/sbin/kadmin %{path}/sbin/
ln -sf /usr/kerberos/sbin/ktutil %{path}/sbin/
ln -sf /usr/kerberos/sbin/krb5-send-pr %{path}/sbin/
ln -sf /usr/kerberos/sbin/krb524d %{path}/sbin/
# RHEL/SL/SLF5 versions are 1.6.*
# With MIT >=1.8, old clients now in RHEL6 krb5-appl-clients
# RHEL5/6 puts this Kerberos stuff in /usr/kerberos
%{applset1}
%{applset2}
# RHEL/SL/SLF5 versions are 1.6.*
# With MIT >=1.8, old servers now in RHEL6 krb5-appl-servers
# RHEL5/6 puts this Kerberos stuff in /usr/kerberos
%{applset3}

%triggerun -p /bin/bash -- krb5-workstation < 1.7
[ "$2" -eq "0" ] || exit 0
echo " >> Removing krb5/bin and krb5/sbin symlinks"
rm -f %{path}/bin/kdestroy %{path}/bin/klist %{path}/bin/kpasswd
rm -f %{path}/bin/ksu %{path}/bin/krb524init %{path}/bin/v4rcp
rm -f %{path}/bin/kvho %{path}/sbin/k5srvutil %{path}/sbin/kadmin
rm -f %{path}/sbin/ktutil %{path}/sbin/krb5-send-pr %{path}/sbin/krb524d
%{applunset1}
%{applunset2}
%{applunset3}


%triggerin -- krb5-workstation > 1.7
echo " >> Adding krb5/bin and krb5/sbin symlinks"
# RHEL/SL/SLF6 versions are MIT >=1.8.*
# RHEL6 puts some base Kerbreros stuff in /usr/bin
ln -sf /usr/bin/kdestroy %{path}/bin/
fpm=`stat -c %a /usr/bin/kdestroy`
if [ "$fpm" -eq "4777" -o "$fpm" -eq "0777" ]; then
	echo " >> Correcting kdestroy permissions"
	chmod 0755 /usr/bin/kdestroy
fi
ln -sf /usr/bin/klist %{path}/bin/
ln -sf /usr/bin/kpasswd %{path}/bin/
ln -sf /usr/bin/ksu %{path}/bin/
if [ "`stat -c %a /usr/bin/ksu`" -eq "4777" ]; then
	echo " >> Correcting ksu permissions"
	chmod 4755 /usr/bin/ksu
fi
ln -sf /usr/bin/kadmin %{path}/sbin/
ln -sf /usr/bin/ktutil %{path}/sbin/
ln -sf /usr/bin/kvno %{path}/bin/
ln -sf /usr/sbin/krb5-send-pr %{path}/sbin/
ln -sf /usr/bin/k5srvutil %{path}/sbin/

%triggerun -p /bin/bash -- krb5-workstation > 1.7
[ "$2" -eq "0" ] || exit 0
echo " >> Removing krb5/bin and krb5/sbin symlinks"
rm -f %{path}/bin/kdestroy %{path}/bin/klist %{path}/bin/kpasswd
rm -f %{path}/bin/ksu %{path}/sbin/kadmin %{path}/sbin/ktutil
rm -f %{path}/bin/kvno %{path}/sbin/krb5-send-pr %{path}/sbin/k5srvutil


%triggerin -- krb5-appl-clients
echo " >> Adding krb5/bin symlinks for clients"
# RHEL/SL/SLF5 versions are 1.6.*
# With MIT > =1.8, old clients now in RHEL6 krb5-appl-clients
# RHEL5/6 puts this Kerberos stuff in /usr/kerberos
%{applset1}
%{applset2}

%triggerun -p /bin/bash -- krb5-appl-clients
[ "$2" -eq "0" ] || exit 0
echo " >> Removing krb5/bin symlinks for clients"
%{applunset1}
%{applunset2}


%triggerin -- krb5-appl-servers
echo " >> Adding krb5/bin symlinks for servers"
# RHEL/SL/SLF5 versions are 1.6.*
# With MIT >=1.8, old servers now in RHEL6 krb5-appl-servers
# RHEL5/6 puts this Kerberos stuff in /usr/kerberos
%{applset1}
%{applset3}

%triggerun -p /bin/bash -- krb5-appl-servers
[ "$2" -eq "0" ] || exit 0
echo " >> Removing krb5/bin symlinks for servers"
%{applunset1}
%{applunset3}


# Kerberos sample clients/servers for RHEL6.*
%triggerin -- krb5-devel > 1.7
echo " >> Adding krb5/*bin symlinks for Samples"
# RHEL/SL/SLF6 versions are MIT >=1.8.*
# RHEL6 puts some Development Kerbreros stuff in /usr/bin and /usr/sbin
ln -sf /usr/bin/gss-client %{path}/bin/
ln -sf /usr/bin/krb5-config %{path}/bin/
ln -sf /usr/bin/sclient %{path}/bin/
ln -sf /usr/bin/sim_client %{path}/bin/
ln -sf /usr/bin/uuclient %{path}/bin/
ln -sf /usr/sbin/gss-server %{path}/sbin/
ln -sf /usr/sbin/sim_server %{path}/sbin/
ln -sf /usr/sbin/sserver %{path}/sbin/
ln -sf /usr/sbin/uuserver %{path}/sbin/

%triggerun -p /bin/bash -- krb5-devel > 1.7        
[ "$2" -eq "0" ] || exit 0
echo " >> Removing krb5/*bin symlinks for Samples"
rm -f %{path}/bin/gss-client %{path}/bin/krb5-config %{path}/bin/sclient \
	%{path}/bin/sim_client %{path}/bin/uuclient %{path}/sbin/gss-server \
	%{path}/sbin/sim_server %{path}/sbin/sserver %{path}/sbin/uuserver


# Kerberos sample clients/server for RHEL5.*
%triggerin -- krb5-devel < 1.7
echo " >> Adding krb5/*bin symlinks for Samples"
# RHEL/SL/SLF5 versions are MIT 1.6.*
# RHEL5 puts Kerberos stuff in /usr/kerberos
ln -sf /usr/kerberos/bin/krb5-config %{path}/bin/
ln -sf /usr/kerberos/bin/sclient %{path}/bin/
ln -sf /usr/kerberos/sbin/sserver %{path}/bin/

%triggerun -p /bin/bash -- krb5-devel < 1.7
[ "$2" -eq "0" ] || exit 0
echo " >> Removing krb5/*bin symlinks for Samples"
rm -f %{path}/bin/krb5-config %{path}/bin/sclient %{path}/bin/sserver


%triggerin -- krb5-workstation < 1.7
echo " >> Adding krb5/*bin symlinks for Samples"
ln -sf /usr/kerberos/bin/gss-client %{path}/bin/
ln -sf /usr/kerberos/bin/sim_client %{path}/bin/
ln -sf /usr/kerberos/bin/uuclient %{path}/bin/
ln -sf /usr/kerberos/sbin/gss-server %{path}/sbin/
ln -sf /usr/kerberos/sbin/sim_server %{path}/sbin/
ln -sf /usr/kerberos/sbin/uuserver %{path}/sbin/

%triggerun -p /bin/bash -- krb5-workstation < 1.7
[ "$2" -eq "0" ] || exit 0
echo " >> Removing krb5/*bin symlinks for Samples"
rm -f %{path}/bin/gss-client %{path}/bin/sim_client %{path}/bin/uuclient \
	%{path}/sbin/gss-server %{path}/sbin/sim_server %{path}/sbin/uuserver


%files
%defattr(0755,root,root)
%dir %{path}
%dir %{path}/bin
%dir %{path}/config
%dir %{path}/include
%dir %{path}/lib
%dir %{path}/man
%dir %{path}/man/man1
%dir %{path}/man/man5
%dir %{path}/man/man8
%dir %{path}/sbin

%{path}//bin/kinit
%{path}//bin/kinit-debug

%dir /etc/profile.d/

#%config /etc/profile.d/aklog.sh
#%config /etc/profile.d/aklog.csh
%config /etc/profile.d/z_krb5.sh
%config /etc/profile.d/z_krb5.csh

%attr(0711,root,root)  %dir /var/adm/
%attr(2711,root,root)  %dir /var/adm/krb5/

%changelog
* Thu Oct 16 2014 Frank Nagy  < nagy@fnal.gov >  2.2-2
- Modify the aklog.csh/sh and z_krb5.csh/sh scripts for
- /etc/profile.d/ replace "aklog" by "/usr/bin/aklog -noprdb"

* Wed Oct 15 2014 Frank Nagy  < nagy@fnal.gov >  2.2-1
- Modified kinit and kinit-debug scripts to (1) invoke aklog
- provided with OpenAFS (as /usr/bin/aklog) and (2) added the
- -noprdb option to aklog call so it will work for both normal
- user principals and compound principals

* Mon Dec 05 2011 Frank Nagy  < nagy@fnal.gov >  2.1-14
- Re-recorrect z_krb5.csh so path varialbe is setup with
- correct word list.  Shell will automaintian PATH variable
- to matxh

* Mon Nov 07 2011 Frank Nagy  < nagy@fnal.gov >  2.1-13
- Minor fix to z_krb5.csh correcting the syntax for the
- command setting the PATH

* Tue Aug 30 2011 Frank Nagy  < nagy@fnal.gov >  2.1-12
- no changes, new release to test that %triggerun works
- correctly during update

* Tue Aug 30 2011 Frank Nagy  < nagy@fnal.gov >  2.1-11
- Another try to get the [] test condition correct

* Tue Aug 30 2011 Frank Nagy  < nagy@fnal.gov >  2.1-10
- New release for testing upgrades and fix to SLF5 code

* Tue Aug 30 2011 Frank Nagy  < nagy@fnal.gov >  2.1-9
- Another set of fixes for the permissions tests and fixes
- Do stat and chmod on /usr/bin files, not symlinks
- Correct kdestroy and v4rcp permissions (no setuid)

* Thu Aug 25 2011 Frank Nagy  < nagy@fnal.gov >  2.1-8
- Yet another try at the %triggerun exit test

* Thu Aug 25 2011 Frank Nagy  < nagy@fnal.gov >  2.1-7
- More work on %triggerun scriptlets

* Thu Aug 25 2011 Frank Nagy  < nagy@fnal.gov >  2.1-6
- Continue work to fix %triggerun problems

* Thu Aug 25 2011 Frank Nagy  < nagy@fnal.gov >  2.1-5
- Fix link removal macros applunset*

* Thu Aug 25 2011 Frank Nagy  < nagy@fnal.gov >  2.1-4
- Fix problem of %triggerun undoing %triggerin when
- installing upgrade

* Thu Aug 25 2011 Frank Nagy  < nagy@fnal.gov >  2.1-3
- Conditionalize fixing the permissions that previous
- releases had wrongly changed

* Wed Aug 24 2011 Frank Nagy  < nagy@fnal.gov >  2.1-2
- Fix chmod permissions to undo previous error

* Thu Aug 11 2011 Frank Nagy  < nagy@fnal.gov >  2.1-1
- Added triggerun scriptlets to match existing triggerin
- scripts and remove the symbolic links on uninstalls
- Added corrected z_krb5 scripts for /etc/profile.d to handle
- change in SLF6 to df output if no AFS volumes

* Tue Jun 28 2011 Frank Nagy  < nagy@fnal.gov >  2.0-2
- Removed "$RPM_BUILD_ROOT/" from all the commands in the
- %triggerin sections and definitions of macros used therein

* Fri May 20 2011 Frank Nagy  < nagy@fnal.gov >  2.0-1
- Changes to use %defattr and handle both RHEL5 and RHEL6
- using %trigger* to set symbolic links correctly based on
- which package(s)/version(s) are installed/removed

* Thu Jan 13 2011 Frank Nagy  < nagy@fnal.gov >  1.1-2
- Added kinit-debug script, same as kinit but -V on
- kinit command and -d on aklog command.

* Wed Jan 05 2011 Frank Nagy  < nagy@fnal.gov >  1.1-1
- Replaced symbolic link for kinit with executable script
- called kinit which calls /usr/kerberos/bin/kinit and,
- if on an AFS client system, aklog since the kinit from
- MIT/Redhat knows not of aklog!

* Wed Apr 14 2010 Frank Nagy  < nagy@fnal.gov >  1.0-2
- Updated z_krb5.* scripts (stored in /etc/profile.d/) to speed-up by 
- reducing unnecessary invocations of aklog when spawning subshells.

* Fri Oct 09 2009 Frank Nagy  < nagy@fnal.gov >  1.0-1
- Created from Troy's krb5-fermi-config for SLF5.x and my original
- krb5-fermi-baseconfig attempt
